<link rel="import" href="../../polymer/polymer-element.html">
<link rel="import" href="../../paper-card/paper-card.html">
<link rel="import" href="../../iron-image/iron-image.html">
<link rel="import" href="../../iron-icon/iron-icon.html">
<link rel="import" href="../../paper-button/paper-button.html">
<link rel="import" href="../collectar-service/collectar-service.html">

<dom-module id="collectar-card">
  <template>
    <style>
      :host {
        display: block;
        transition: opacity ease 0.35s;
        opacity: 0;
      }
      paper-card {
        display: inline-block;
        width: 100%;
        margin: 0;
        position: relative;
      }
      paper-card:hover .card-content {
        opacity: 1;
      }
      .card-content {
        position: absolute;
        bottom: 0;
        opacity: 0;
        right: 0;
        left: 0;
        transition: opacity ease .35s;
        background: rgba(0,0,0,0.7);
        color: white;
        @apply --collectar-card-content;
      }
      iron-icon {
        border-radius: 50%;
        color: white;
        background: rgba(0,0,0,0.3);
        position: absolute;
        right: 16px;
        bottom: 16px;
      }
      paper-button {
        position: absolute;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        color: white;
      }
      .image, .thumbnail {
        --iron-image-width: 100%;
        width: 100%;
        transition: opacity ease .35s;
      }
      [hidden] {
        opacity: 0;
        position: absolute;
        top: 0;
      }
      .hide { overflow: hidden; }
      .thumbnail {
        filter: blur(5px);
        margin-bottom: -7px;
        transform: scale(1.1);
      }
      .image:not([hidden]) {
        opacity: 1;
        position: unset;
        margin-bottom: -8px;
      }
      .item-header { @apply(--paper-font-headline); }
      .item-light { color: var(--paper-grey-600); }
      .card-content h4 {
        margin: 0;
        font-weight: bold;
      }
      .description-row {
        font-size: 14px;
      }
    </style>
    <collectar-service id="ajax"></collectar-service>
    <paper-card elevation="0">
      <div class="hide">
      <iron-image class="thumbnail" hidden="[[loaded]]"
        src="{{_thumbnail(cardItem)}}"></iron-image>
      </div>
      <iron-image class="image" hidden="[[!loaded]]" loaded="{{loaded}}"  src="{{mediaPath}}"></iron-image>
      <div class="card-content">
        <h4>{{cardItem.name}}</h4>
        <div class="description-row">
          <dom-if if="{{cardItem._taxonomy}}">
            <template>
              <span>{{cardItem._taxonomy.name}}</span>
            </template>
          </dom-if>
          <dom-if if="{{cardItem.dimensions.width}}">
            <template>
              <span>{{cardItem.dimensions.height}} X {{cardItem.dimensions.width}}</span>
            </template>
          </dom-if>
        </div>
        <div class="description-row">
          <span>{{_cardDate(cardItem)}}</span>
        </div>
        <!-- <iron-icon icon="info"></iron-icon> -->
      </div>
      <paper-button class="overlay" on-tap="fireShowItem"></paper-button>
    </paper-card>
  </template>

  <script>
    /**
     * `collectar-card`
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class collectarCard extends Polymer.Element {
      static get is() { return 'collectar-card'; }
      static get properties() {
        return {
          projectId: String,
          cardItem: Object,
          server: String,
          mediaPath: String,
          enabledFields: String
        };
      }

      static get observers() {
        return ['_mediaPath(projectId, server, cardItem)'];
      }

      connectedCallback() {
        super.connectedCallback();
        setTimeout(function() {
          this.style.opacity = "1";
        }.bind(this), 800);
      }

      fireShowItem(e) {
        this.dispatchEvent(new CustomEvent('show-item', {
          detail: { cardItem: this.cardItem },
          bubbles: true, composed: true }));
      }

      _thumbnail(cardItem) {
        if(!cardItem) return;
        return cardItem.thumbnail;
      }

      _cardDate(cardItem) {
        if(!cardItem || !cardItem.date || !cardItem.date.dates.length) return;
        const d1 = new Date(cardItem.date.dates[0]);
        const d2 = new Date(cardItem.date.dates[1]);
        switch(cardItem.date.dateType) {
          case "decades":
            return `${d1.getYear()} - ${d2.getYear()}`;
            break;
          case "year":
            return `${d1.getYear()}}`;
            break;
          case "fullDate":
            return `${d1.getDate()}/${d1.getMonth()}/${d1.getFullYear()}`;
            break;
        }
      }

      _mediaPath(projectId, server, cardItem) {
        if(!projectId || !server || !cardItem ||
          !cardItem._medias || !cardItem._medias.length) return;
        this.mediaPath = `${server}/projects/${projectId}/medias/${
          this.cardItem._item}/${this.cardItem._medias[0].filename}?size=400`;
        if(this.mediaPath) this.set('cardItem.image', this.mediaPath);
      }

    }

    window.customElements.define(collectarCard.is, collectarCard);
  </script>
</dom-module>
